/*
    Copyright (C) 2003 Fons Adriaensen <fons.adriaensen@skynet.be>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef __AUDIO_H
#define __AUDIO_H


#include <stdlib.h>
///#include <clthreads.h>
///#include <clalsadrv.h>
///#include <jack/jack.h>
#include "reverb.h"
#include "audiodiv.h"
#include "stopwave.h"


#define NDIVIS 4
#define NSTOPS 24
#define NNOTES 61


class Audio ///: public A_thread
{
public:

    Audio (/* ITC_ctrl *cmain */);
    virtual ~Audio (void);

    ///void  init_alsa (const char *name, int fsamp, int fsize, int nfrag, int ncapt, int nplay, bool bform);
    ///void  init_jack (int ncapt, int nplay, bool bform);

private:

    enum { NBANK = 10, NSMEM = 100 };

    void init_audio (void);
    void init_midi (void);
    ///void close_alsa (void);
    ///void close_jack (void);
    ///void close_midi (void);
    ///void reset_midi (unsigned int bits);
    void update_div (unsigned int, unsigned int); 
    void update_all (unsigned int *, unsigned int *);
 
    virtual void thr_main (void);
    ///int   jack_callback (jack_nframes_t);

    void proc_mesg (void);
    void proc_midi (void);
    void proc_synth (unsigned long);
    void define_stop (int d, int i, Stopwave *, int pan, int del);
    void update_stop (int d, int i, bool a);
    void update_func (unsigned int b, bool a);
    void update_regs (unsigned int *s);
    void store_regs (unsigned int *s);
    void recall (int d);
    void tstmem (void);
    void mstore (void);
    void insert (void);
    void remove (void);

    ///static int jack_static_callback (jack_nframes_t, void *);

    ///ITC_ctrl       *_cmain;

    ///volatile bool   _run_alsa;
    ///volatile bool   _run_jack;
    ///Alsa_driver    *_alsa_handle;
    ///jack_client_t  *_jack_handle;
    ///jack_port_t    *_jack_in  [8];
    ///jack_port_t    *_jack_out [8];
    ///snd_seq_t      *_midi_handle;
    ///int             _midi_port;
    bool            _bform;
    int             _ncapt;
    int             _nplay;
    int             _fsamp;
    int             _fsize;
    float          *_out [8];
    unsigned int    _stat [NDIVIS + 1];
    unsigned int    _chan [NDIVIS + 1];
    unsigned int    _mask [NDIVIS];
    unsigned char   _keys [NNOTES];
    Stopwave       *_wave [NDIVIS][NSTOPS]; 
    Audiodiv       *_adiv0;
    Audiodiv       *_adiv1;
    Audiodiv       *_adiv2;
    Quadfdn         _qfdn;
    float           _apar [4];
    float           _aval [4];
    int             _mpar [3];
    unsigned       *_smem; 
    bool            _pres;
};


#endif

