/*
    Copyright (C) 2003 Fons Adriaensen <fons.adriaensen@skynet.be>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef __MESSAGES_H
#define __MESSAGES_H


///#include <clxclient.h>
#include "stopwave.h"
#include "audiodiv.h"
#include "def_addsynth1.h"


enum 
{
    CB_MIDI_OFF, /// = X_callback::USER_CB,
    CB_MIDI_MSK,
//    CB_EDIT_DEL,
    CB_EDIT_APP,
    CB_EDIT_END,
    CB_SC_HARM,
    CB_SC_NOTE,
    CB_MS_SEL,
    CB_MS_UPD,
    CB_MS_DEF,
    CB_MS_UND,
    CB_FW_SEL,
    CB_FW_UPD,
    CB_FW_DEF,
    CB_FW_UND
};


enum
{
    AT_MESG0 = 0,
    AT_EXIT  = 31,
    MAIN_EV  = 1,
    EDIT_EV  = 2
};


enum
{
    MT_AUD_PARM,
    MT_DEF_STOP,
    MT_STOP_ON,
    MT_STOP_OFF,
    MT_FUNC_ON,
    MT_FUNC_OFF,
    MT_SET_REGS,
    MT_MIDI_OFF,
    MT_PRES_ON,
    MT_PRES_OFF,
    MT_SET_MEM,
    MT_DECRB,
    MT_INCRB,
    MT_DECRM,
    MT_INCRM,
    MT_DECRM10,
    MT_INCRM10,
    MT_RECALL,
    MT_DECREC,
    MT_INCREC,
    MT_MSTORE,
    MT_INSERT,
    MT_DELETE
};


class M_audiopar ///: public ITC_mesg
{
public:

    M_audiopar (void) {} ///: ITC_mesg (MT_AUD_PARM) {}

    float           _fsamp;
    unsigned int   *_mchan;
    Audiodiv       *_adiv0;
    Audiodiv       *_adiv1;
    Audiodiv       *_adiv2;
    float          *_apar;
    int            *_mpar;
    unsigned int   *_smem;
};


class M_defstop ///: public ITC_mesg
{
public:

    M_defstop (int type){} ///: ITC_mesg (type) {}

    unsigned int    _div;
    unsigned int    _ind;
    float           _fsamp;
    float           _fbase;
    float          *_scale;
    int             _pan;
    int             _del;
    Stopwave       *_wave;
    Def_addsynth1  *_stop;
};


class M_setregs ///: public ITC_mesg
{
public:

    M_setregs (void) {}///:  ITC_mesg (MT_SET_REGS) {}

    unsigned int   _regs [5];
};


class M_stopstat ///: public ITC_mesg
{
public:

    M_stopstat (int type, int div, int ind){} /// :  ITC_mesg (type), _div (div), _ind (ind)  {} 

    int   _div;
    int   _ind;
};


class M_funcstat ///: public ITC_mesg
{
public:

    M_funcstat (int type, int bits){} /// :  ITC_mesg (type), _bits (bits) {}

    unsigned int   _bits;
};


class M_midi_off /// : public ITC_mesg
{
public:

    M_midi_off (unsigned int bits) {}///:  ITC_mesg (MT_MIDI_OFF), _bits (bits) {}

    unsigned int   _bits;
};


#endif
 
