/*
    Copyright (C) 2003 Fons Adriaensen <fons.adriaensen@skynet.be>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef __MIDIMATRIX_H
#define __MIDIMATRIX_H


#include "messages.h"


class Midimatrix : public X_window
{
public:

    Midimatrix (X_window *parent, int xp, int yp, X_callback *callb);
    ~Midimatrix (void);
 
    virtual void handle_event (XEvent *xe);

    void set_bits (unsigned int *bits);
    int  get_bits (unsigned int *bits);

private:

    enum { XL = 24, XR = 3, YT = 3, YB = 22, DX = 22, DY = 22,
           XSIZE = 16 * DX + XL + XR,
           YSIZE = 5 * DY + YT + YB };

    void expose (XExposeEvent *E);
    void redraw (void);
    void plot_grid (void);
    void plot_conn (int x, int y);
    void bpress (XButtonEvent *E);

    X_callback     *_callb;
    unsigned long   _bgnd;
    unsigned long   _grid;
    unsigned long   _text;
    unsigned long   _conn;
    unsigned int    _bits [5];
    int             _doff;

    static const char *_text1 [5];
};


#endif
