/*
    Copyright (C) 2003 Fons Adriaensen <fons.adriaensen@skynet.be>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef __REVERB_H
#define __REVERB_H


class Diffuser
{
public:
    
    void init (int size, float c);
    void fini (void);
    int  size (void) { return _size; }
    float process (float x)
    {
        float w;
 
        w = x - _c * _data [_i];
        x = _data [_i] + _c * w;
        _data [_i] = w;
        if (++_i == _size) _i = 0;
        return x;
    }

private:

    float     *_data;
    int        _size;
    int        _i;
    float      _c;
};



class Quadfdn
{
public:
    
    void init (float rate, float size);
    void fini (void);
    void set_roomsize (float size);
    void set_revbtime (float time);
    void process (int n, float gain, float *R, float *W, float *X, float *Y, float *Z);
    void process_st (int n, float gain, float *R, float *W, float *X, float *Y, float *Z);

private:

    float       *_data [4];
    float        _rate;
    float        _time;
    int          _size;
    float        _c0;
    float        _c1;
    float        _gl [4];
    float        _gh [4];
    float        _y [4];
    float        _z [4];
    int          _d [4];
    int          _i;
    float        _zx;
    float        _zy;
    Diffuser     _dif [4];
};


#endif
