/*
    Copyright (C) 2003 Fons Adriaensen <fons.adriaensen@skynet.be>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef __STYLES_H
#define __STYLES_H


#include <clxclient.h>


struct colors
{
    unsigned long   white;
    unsigned long   black;
    unsigned long   main_bg;
    unsigned long   main_fg;
    unsigned long   main_ds;
    unsigned long   main_ls;
    unsigned long   text_bg;
    unsigned long   text_hl;
    unsigned long   text_fg;
    unsigned long   text_ca;
    unsigned long   slid_kn;
    unsigned long   slid_mk;
    unsigned long   butt_b0;
    unsigned long   butt_b1;
    unsigned long   butt_fg;
    unsigned long   func_bg;
    unsigned long   func_gr;
    unsigned long   func_d0;
    unsigned long   func_d1;
    unsigned long   func_mk;
    unsigned long   func_d2;
    unsigned long   midi_bg;
    unsigned long   midi_gr;
    unsigned long   midi_tx;
    unsigned long   midi_co;
};


struct fonts 
{
    XFontStruct   *main;
    XFontStruct   *large;
    XFontStruct   *stops;
    XFontStruct   *button;
    XFontStruct   *scales;
    XFontStruct   *midimt;
};


extern struct colors    Colors;
extern struct fonts     Fonts;
extern X_scale_style    sca_dBsh, sca_dBsm, sca_dBlg, sca_Tatt, sca_Patt, sca_0_12, sca_Tu1, sca_Tu2;
extern X_scale_style    sca_difg, sca_size, sca_trev, sca_brig, sca_Tfr, sca_Tmd;
extern X_button_style   but0, but1;
extern X_menuwin_style  menu1;
extern X_textln_style   text0, text1;
extern X_slider_style   sli1; 
 
extern void init_styles (X_display *disp, X_resman *xrm);


#endif
